/* For license details see bottom.
 * Copyright (c) 2002 Catalyst of Design (David Morris-Oliveros).  All rights reserved.
 */

/**
 *<br> class:		<none>
 *<br> namespace:	caosGL::core
 *<br> inherits:	<none>
 *<br> implements:	<none>
 *<br> purpose:		
 *
 */

#ifndef CAOSGL_CORE_GLOBALS
#define CAOSGL_CORE_GLOBALS

#include <log4cpp/Category.hh>
#include <log4cpp/NDC.hh>

#ifdef CAOSGL_EXPORTS
#define CAOSGL_API __declspec(dllexport)
#else
#define CAOSGL_API __declspec(dllimport)
#endif

#define ABSTRACT __declspec(novtable)
#define INTERFACE __declspec(novtable)

//automatic attribute generation...
#define MACRO_PASTE(x,y) x##y
#define ATTRIB_DEFINE_VAR(n,t) t MACRO_PASTE(_,n);
#define ATTRIB_INIT_VAR(n,v) MACRO_PASTE(_,n) = v;
#define ATTRIB_ATTRIBNAMES(n,d) attributeNames.push_back(make_pair(#@n,string(d)));
#define ATTRIB_GET(n) case #@n: { value = cParser::toString (MACRO_PASTE(_,n)); } return true;
#define ATTRIB_SET_N(n) case #@n: { cParser::convert (MACRO_PASTE(_,n), value); } return true;
#define ATTRIB_SET_S(n) case #@n: { cParser::parse (MACRO_PASTE(_,n), value); } return true;

// simbol too long
#pragma warning(disable:4786)
// dll interface to be used by clientes
#pragma warning(disable:4251)
//truncation from 'const double' to 'float
#pragma warning(disable:4305)
//conversion from 'double' to 'float'
#pragma warning(disable:4244)

#endif // CAOSGL_CORE_GLOBALS

/**
 * The Catalyst of Design Software License, Version 1.0
 *
 * Copyright (c) 2002 Catalyst of Design (David Morris-Oliveros).  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by 
 *        Catalyst of Design (http://talsit.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "caosGL" and "Catalyst of Design" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact caosGL@talsit.org.
 *
 * 5. Products derived from this software may not be called "caosGL",
 *    nor may "caosGL" appear in their name, without prior written
 *    permission of Catalyst of Design.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL CATALYST OF DESIGN OR ITS 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 */
// eof